
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Paul Medlock.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Paul Medlock, <paul@medlock.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


//*********************************************************************
// atom.h
//*********************************************************************

#ifndef ATOM_H
#define ATOM_H

#ifndef FARBOOK_H
#include "common.h"
#endif

//=====================================================================
// farVIEW class identifiers
//
// Ima codes for classes derived from CAtom
//
const ushort iNoType                =  0;
const ushort iArgs                  =  1;
const ushort iAtom                  =  2;
const ushort iManifest              =  3;           // used by CFactory
const ushort iBook                  =  4;
const ushort iBookInfo              =  5;
const ushort iBlock                 =  6;           // used by CFactory
const ushort iBlowfish              =  7;
const ushort iBoolean               =  8;
const ushort iSession               =  9;
const ushort iSessionDict           = 10;
const ushort iChars                 = 11;
const ushort iChunk                 = 12;
const ushort iCloseSession          = 13;
const ushort iComm                  = 14;
const ushort iCommCmmd              = 15;
const ushort iCommResult            = 16;
const ushort iConnection            = 17;
const ushort iConnectionDict        = 18;
const ushort iConsole               = 19;
const ushort iCriticalSection       = 20;
const ushort iListen                = 21;
const ushort iFarSlang              = 46;      // don't change casually
const ushort iFile                  = 22;
const ushort iFileList              = 23;
const ushort iFindItem              = 24;
const ushort iFindList              = 25;
const ushort iHash                  = 26;
const ushort iHshList               = 27;           // used by CFactory
const ushort iIniList               = 28;           // used by CFactory
const ushort iItem                  = 29;
const ushort iProcess               = 30;
const ushort iList                  = 31;           // used by CFactory
const ushort iLong                  = 32;
const ushort iMap                   = 33;           // used by CFactory
const ushort iOpenSession           = 34;
const ushort iPort                  = 35;
const ushort iPreferences           = 36;
const ushort iPtrItem               = 37;
const ushort iRecord                = 38;           // used by CFactory
const ushort iReceiveMessage        = 39;
const ushort iRef                   = 40;
const ushort iRefs                  = 41;
const ushort iRifList               = 42;           // used by CFactory
const ushort iSearchFile            = 43;
const ushort iSemaphore             = 44;
const ushort iSendMessage           = 45;
const ushort iSocket                = 47;
const ushort iStrItem               = 48;
const ushort iStrList               = 49;           // used by CFactory
const ushort iString                = 50;           // used by CFactory
const ushort iThread                = 51;
const ushort iTree                  = 52;           // used by CFactory
const ushort iObject                = 53;
const ushort iListBlock             = 54;           // used by CFactory

const ushort iDOMException          = 55;
const ushort iDOMImplementation     = 56;
const ushort idomRelations          = 57;
const ushort idomMethods            = 58;
const ushort iNode                  = 59;
const ushort iNodeList              = 60;
const ushort iNamedNodeMap          = 61;
const ushort iElement               = 62;
const ushort iAttr                  = 63;
const ushort iCharacterData         = 64;
const ushort iText                  = 65;
const ushort iCDATASection          = 66;
const ushort iEntityReference       = 67;
const ushort iEntity                = 68;
const ushort iProcessingInstruction = 69;
const ushort iComment               = 70;
const ushort iDocument              = 71;
const ushort iDocumentType          = 72;
const ushort iDocumentFragment      = 73;
const ushort iNotation              = 74;
const ushort iOpenConnect           = 75;
const ushort iRegX                  = 76;
const ushort iFSSAX                 = 77;
const ushort iLocalBook             = 78;
const ushort iRemoteBook            = 79;
const ushort iFileItem              = 80;
const ushort iFileOps               = 81;
const ushort iSearch                = 82;
const ushort iRemoteFile            = 83;
const ushort iPoint                 = 84;
const ushort iUrl                   = 85;
const ushort iXPath                 = 86;
const ushort iXPathItem             = 87;
const ushort iDate                  = 88;
const ushort iTime                  = 89;
const ushort iBugger                = 90;
const ushort iVar                   = 91;
const ushort iVars                  = 92;
const ushort iStem                  = 93;
const ushort iXText                 = 94;
const ushort iTXTType               = 95;
const ushort iTXTFile               = 96;
const ushort iXMLFile               = 97;
const ushort iXMLTree               = 98;
const ushort iRecall                = 99;
const ushort iVolMap                = 100;
const ushort iTokens                = 101;
const ushort iLock                  = 102;

// Note: add new ones to the end until the
// next major update to avoid losing your
// farVIEW farBook.

//=====================================================================
// farVIEW base class
//

_FBDEF(CAtom)
class FBC_USE CAtom {
   public:
      static bool debugLeaks;
      
      static FB_USE_(Pchar) GetTypeName(short _iType);

      FB_USE CAtom(void);
      FB_USE CAtom(PCAtom _atom);
      virtual FB_USE ~CAtom();

      virtual FB_USE_(short) Ima(void);
      virtual FB_USE_(Pchar) IAm(void);
      virtual FB_USE_(bool)  Isa(const short _type);

      virtual FB_USE_(void)  SetError(ulong _err);
      virtual FB_USE_(ulong) Error(void);

      FB_USE_(void)          Enter(void);
      FB_USE_(void)          Leave(void);

      virtual FB_USE_(bool)  CallBack(ulong _value);

      //??DMY      FB_USE_(CAtom) operator =(PCAtom _b);

#ifndef _SLANGER
      FB_USE_(short)         NrRefs   (void) { return nrRefs; }
      FB_USE_(short)         RegRef   (void);
      FB_USE_(short)         DrgRef   (void);
#endif // _SLANGER

      virtual FB_USE_(void)  SetDirty (bool _dirty, depth _deep);
      virtual FB_USE_(bool)  IsDirty  (depth _deep);
      
      virtual FB_USE_(bool)  BlockTo  (PCAtom _block);
      virtual FB_USE_(bool)  ToBlock  (PCAtom _block);

      FB_USE_(ulong)         Id       (void) { return id; }
      
      virtual FB_USE_(ulong) BookSize (void);

      virtual FB_USE_(bool)  ReadFile   (PCAtom _input, bool _isBook);
      virtual FB_USE_(bool)  WriteFile  (PCAtom _output, bool _isBook);

      virtual FB_USE_(bool)  ReadRemote (PCAtom _input);
      virtual FB_USE_(bool)  WriteRemote(PCAtom _output);

      virtual FB_USE_(bool)  Load       (Pchar _fileName);
      virtual FB_USE_(bool)  Save       (Pchar _fileName);

   protected:
      ulong  cls;
      ulong  id;
      ulong  err;
      ulong  id2;
      bool   dirty;
      short  nrRefs;

#if   defined(FV_THREADS)
#if   defined(FV_MSWIN16)
      #warning Critical Section not supported

#elif defined(FV_MSWIN32)
      CRITICAL_SECTION crtsec;

#elif defined(FV_MACINTOSH)
      #warning FV_MACINTOSH TBD

#elif defined(FV_UNIX)
      #warning FV_UNIX TBD

#endif // FV_UNIX
#endif // FV_THREADS
   }; // CAtom

//---------------------------------------------------------------------
//
inline short CAtom::RegRef(void) {
   if (id2 != id)
      Assert(id2 == id);

   return ++nrRefs;
   } // RegRef

//---------------------------------------------------------------------
//
inline short CAtom::DrgRef(void) {
   if (id2 != id)
      Assert(id2 == id);

   if (nrRefs > 0)
      --nrRefs;

   return nrRefs;
   } // DrgRef

//---------------------------------------------------------------------
//
inline void CAtom::SetDirty(bool _dirty, depth _deep) {
   _deep;

   dirty = _dirty;
   } // SetDirty

//---------------------------------------------------------------------
//
inline bool CAtom::IsDirty(depth _deep) {
   _deep;

   return dirty;
   } // IsDirty

#endif // ATOM_H

