
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Paul Medlock.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Paul Medlock, <paul@medlock.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


//*********************************************************************
// hshlist.h
//*********************************************************************

#ifndef HSHLIST_H
#define HSHLIST_H

#ifndef FARBOOK_H
#include "list.h"
#endif

_FBDEF(CHshList)

class FBC_USE CHshList: public CItem {
   public:
      FB_USE CHshList(short _wide = 32);
      virtual FB_USE ~CHshList();

      virtual FB_USE_(short) Ima(void);
      virtual FB_USE_(Pchar) IAm(void);
      virtual FB_USE_(bool)  Isa(const short _type);

      virtual FB_USE_(void)   Insert(Pvoid    _key,
                                     PCItem  _pItem,
                                     AtWhere  _where = atEnd);
      virtual FB_USE_(PCList) List  (Pvoid _key);

      virtual FB_USE_(PCItem) GetFirstItem(Pvoid _key);
      virtual FB_USE_(PCItem) GetNextItem (void);
      virtual FB_USE_(PCItem) Remove      (AtWhere _where = after,
                                           bool _deleteIt = true);

      virtual FB_USE_(void)   Flush (void);

      FB_USE_(short)          GetWidth(void) { return wide; }
      FB_USE_(PCList)         GetList (short _list);

   protected:
      virtual ushort hash    (Pvoid _key);
      virtual bool   addTable(ushort _i);

      short   wide;
      PCList *table;
      Pvoid   key;
      PCList  list;
   }; // CHshList

#endif // HSHLIST_H

