
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Paul Medlock.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Paul Medlock, <paul@medlock.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


//*********************************************************************
// process.h
//*********************************************************************
//
//   ************ IMPORTANT NOTE FOR MACINTOSH USAGE **************
// You must enable the following SIZE flags for this class to work
// properly:
//       "Background Null Events"
//       "Suspend and Resume Events"
//       "Accept ChildDiedEvents"
//
//       "HighLevelEvent - Aware"
//       "Accept Remote HigLevelEvents"
//
// Without these, the system may hang, or the parent won't know when
// the child process has terminated. (thereby never coming to the
// foreground).
//
//*********************************************************************

#ifndef PROCESS_H
#define PROCESS_H

#ifndef FARBOOK_H
#include "atom.h"
#endif

_FBDEF(CProcess)
class FBC_USE CProcess: public CAtom {
   public:
      FB_USE CProcess         (void);
      virtual FB_USE ~CProcess();

      virtual FB_USE_(short) Ima(void);
      virtual FB_USE_(Pchar) IAm(void);
      virtual FB_USE_(bool)  Isa(const short _type);

      // farSlang version
      FB_USE_(Pchar) FindExecutable (Pchar _file);

      FB_USE_(bool)  Run            (Pchar _cmmd, Pchar _parms, bool _wait);
      FB_USE_(bool)  Run            (Pchar _fileName);

      FB_USE_(bool)  Done           (void);
      FB_USE_(void)  DeleteParmsFile(void);

      FB_USE_(ulong) Error          (void);

   protected:
#if     defined(FV_MSWINDOWS)
      PROCESS_INFORMATION procInfo;
#endif
      bool                amWaiting;   // true if child is not complete
      short               error;        // system-dependent error value
      long                sysErr;
      static Pchar        name;           // path of the parameter file
   }; // CProcess

inline ulong CProcess::Error(void) {
   return error;
   } // Error

#endif // PROCESS_H

