
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Paul Medlock.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Paul Medlock, <paul@medlock.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


// note: _isBook parameter never used

//*********************************************************************
// record.h
//*********************************************************************

#ifndef RECORD_H
#define RECORD_H

#ifndef FARBOOK_H
#include "list.h"
#endif

const short maxSizeRecord = sizeString;
const short maxSizeField  = sizeString;
const short maxNrFields   = 256;

//=====================================================================
// record class definition
//

_FBDEF(CRecord)
class FBC_USE CRecord: public CItem {
   public:
      FB_USE CRecord(void);
      FB_USE CRecord(PCRecord _rec);
      FB_USE CRecord(Pchar _data);
      FB_USE CRecord(Pchar _data,     Pchar     _delm);
      FB_USE CRecord(short _nrFields, Pchar     _delm);
      FB_USE CRecord(Pchar _data,     PCRecord _sizes);

      virtual FB_USE ~CRecord();

      virtual FB_USE_(short) Ima(void);
      virtual FB_USE_(Pchar) IAm(void);
      virtual FB_USE_(bool)  Isa(const short _type);

      FB_USE_(void)  IgnoreQuotes(void) { checkQuotes = false; }

      FB_USE_(void)  SetTemplate (Pchar _template);
#ifndef _SLANGER
      FB_USE_(Pchar) GetTemplate (bool _alc);
#endif // _SLANGER
      FB_USE_(Pchar) GetTemplate (void);            // farSlang version

#ifndef _SLANGER
      FB_USE_(bool)  GetFieldName(short _iField, Pchar _name, short _size);
#endif // _SLANGER
      FB_USE_(Pchar) GetFieldName(short _iField);   // farSlang version

      FB_USE_(void)  Clear       (void);
      FB_USE_(void)  NewRecord   (PCRecord _record);
      FB_USE_(void)  NewRecord   (Pchar _data);
      FB_USE_(void)  NewRecord   (Pchar _data,     Pchar     _delm);
      FB_USE_(void)  NewRecord   (short _nrFields, Pchar     _delm);
      FB_USE_(short) NewRecord   (Pchar _data,     PCRecord _sizes);

      FB_USE_(char)  GetDelimiter(void);
#ifndef _SLANGER
      FB_USE_(void)  GetDelimStr (Pchar _string, short _size);
      FB_USE_(Pchar) GetDelimStr (bool  _alc);
      FB_USE_(void)  GetDelimStrD(Pchar _string, short _size);
      FB_USE_(Pchar) GetDelimStrD(bool  _alc);
#endif // _SLANGER
      FB_USE_(Pchar) GetDelimStr (void);            // farSlang version
      FB_USE_(Pchar) GetDelimStrD(void);            // farSlang version

      FB_USE_(bool)  Empty       (void);
      FB_USE_(short) Number      (void);
      FB_USE_(short) Length      (void) { return Number(); }
      FB_USE_(short) GetFieldNr  (Pchar _name);
      FB_USE_(short) FindField   (Pchar _value, whichEnd _end = bothEnds);

      FB_USE_(short) OfsField    (short _iField);
      FB_USE_(short) LenField    (short _iField);

      FB_USE_(short) TrimField   (short _iField, whichEnd _end = bothEnds);
      FB_USE_(void)  TrimAll     (whichEnd _end = bothEnds);

      FB_USE_(bool)  FieldEmpty  (short _iField);
//?   Pchar operator[](short _iField);

#ifndef _SLANGER
      FB_USE_(bool)  GetField    (short _iField, Pchar _field, short _size);
#endif // _SLANGER
      FB_USE_(Pchar) GetField    (short _iField);   // farSlang version

#ifndef _SLANGER
      FB_USE_(bool)  GetField    (Pchar _name, Pchar _field, short _size);
#endif // _SLANGER
      FB_USE_(Pchar) GetField    (Pchar _name);     // farSlang version

      FB_USE_(bool)   IsNumber      (short _iField);
      FB_USE_(bool)   IsNumber      (Pchar _name);
      FB_USE_(bool)   GetBoolField  (short _iField);
      FB_USE_(bool)   GetBoolField  (Pchar _name);

      FB_USE_(short)  GetIntField   (short _iField);
      FB_USE_(short)  GetIntField   (Pchar _name);
      FB_USE_(long)   GetLongField  (short _iField);
      FB_USE_(long)   GetLongField  (Pchar _name);
      FB_USE_(double) GetDoubleField(short _iField);
      FB_USE_(double) GetDoubleField(Pchar _name);
      FB_USE_(bool)  PutBoolField   (short _iField, bool _field);
      FB_USE_(bool)  PutBoolField   (Pchar _name,   bool _field);

      FB_USE_(bool)  PutField    (short _iField, Pchar    _field);
      FB_USE_(bool)  PutField    (Pchar _name,   Pchar    _field);
      FB_USE_(bool)  PutField    (short _iField, long     _field);
      FB_USE_(bool)  PutField    (Pchar _name,   long     _field);

#ifndef _SLANGER
//?   FB_USE_(bool)  PutLLField  (short _iField, LONGLONG _field);
//?   FB_USE_(bool)  PutLLField  (Pchar _name,   LONGLONG _field);
//?   FB_USE_(bool)  PutULField  (short _iField, LONGLONG _field);    ?
//?   FB_USE_(bool)  PutULField  (Pchar _name,   LONGLONG _field);    ?
#endif // _SLANGER


      FB_USE_(bool)  InsertField (short _iField, Pchar _field);
      FB_USE_(bool)  InsertField (Pchar _name1, Pchar _name2, Pchar _field);
      FB_USE_(bool)  InsertField (Pchar _name1, Pchar _name2, long  _field);

      FB_USE_(bool)  AppendField (Pchar _field);
      FB_USE_(bool)  AppendField (Pchar _name, Pchar _field);

      FB_USE_(bool)  DeleteField (short _iField);
      FB_USE_(bool)  DeleteField (Pchar _name);

      FB_USE_(bool)  Match       (short    _iField,
                                  Pchar    _value,
                                  whichEnd _end = bothEnds);

#ifndef _SLANGER
      FB_USE_(void)  FindField   (short  _iField,
                                  Rshort _iBegin, Rshort _iEnd);
#endif // _SLANGER

      virtual FB_USE_(bool) BlockTo(PCAtom _block);
      virtual FB_USE_(bool) ToBlock(PCAtom _block);

      // io methods
      virtual FB_USE_(ulong) BookSize (void);

      virtual FB_USE_(bool)  ReadFile (PCAtom _input,  bool _isBook);
      virtual FB_USE_(bool)  WriteFile(PCAtom _output, bool _isBook);

      virtual FB_USE_(bool)  ReadThis (PCAtom _input);
      virtual FB_USE_(bool)  WriteThis(PCAtom _output);

      virtual FB_USE_(bool)  Load     (Pchar _fileName);
      virtual FB_USE_(bool)  Save     (Pchar _fileName);

   protected:
      virtual bool match(Pvoid _p);

      struct matchRec {
         matchRec(short _iField, Pchar _value):
            iField(_iField),
            value (_value) {
            } // matchRec

         short iField;
         Pchar value;
         }; // matchRec

      bool  delmAdded;
      bool  checkQuotes;
      Pchar tmplt;
      Pchar chars;
   }; // CRecord

#endif // RECORD_H

