
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Paul Medlock.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Paul Medlock, <paul@medlock.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


//********************************************************************
// refs.h
//*********************************************************************

#ifndef REFS_H
#define REFS_H

#ifndef FARBOOK_H
#include "hash.h"
#endif

#ifndef _SLANGER

//---------------------------------------------------------------------
//
__FBDEF(aRefBucket)
class aRefBucket {
   friend class CRefs;

   protected:
      static
      short   Size(short _nrSlots);
      paRef   Slot(short _iSlot, short _nrSlots);

      ulong next;                  // points to next table for overflow
      aRef  slot[1];
   }; // aRefBucket

#endif // _SLANGER

//---------------------------------------------------------------------
//
_FBDEF(CRefs)
class FBC_USE CRefs: public CHash {
   public:
      FB_USE CRefs(ulong _hdrSize, Pchar _name);
      virtual FB_USE ~CRefs();

      virtual FB_USE_(short) Ima(void);
      virtual FB_USE_(Pchar) IAm(void);
      virtual FB_USE_(bool)  Isa(const short _type);

      FB_USE_(void)    SetSizes   (long _nrRefSlots,
                                   long _nrHshSlots,
                                   long _sizeKey,
                                   long _nrKeys);

      virtual FB_USE_(bool) Create(void);
      virtual FB_USE_(bool) Open  (void);

      FB_USE_(bool)    GetFirstRef(ulong _location, PCRef _ref);
      FB_USE_(bool)    GetNextRef (PCRef _ref);

      FB_USE_(ulong)   InsertRef  (ulong _location, PCRef _ref);
      FB_USE_(bool)    DeleteRef  (ulong _location, PCRef _ref);

   protected:
      bool makeBucket (RaRef _ref);
      bool addToBucket(RaRef _ref);

      short       nrSlots;
      ulong       location;
      short       iSlot;
      PCBlock     refbkt;
      paRefBucket refbucket;  // memory buffer for refbucket operations
   }; // CRefs

#endif // REFS_H

